from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatBase", inherit=True, prefix=None)
c.inheritAllInterfaces("boat")

c.addParameter("length", 228, paramType="length")
c.addParameter("width", 90, paramType="length")
c.addParameter("depth", 70, paramType="length")

c.addSubcomponent("boat", "BoatBase", inherit=True)

c.addConstraint(("boat", "boat.length"), "length")
c.addConstraint(("boat", "boat.width"), "width")
c.addConstraint(("boat", "boat.depth"), "depth")

c.addSubcomponent("servostackbattery", "ServoStackBatteryMount")
c.inheritAllInterfaces("servostackbattery")

c.addConnection(("boat", "portedge"), ("servostackbattery", "lTopSplit")) #both face the same direction
c.addConnection(("boat", "staredge"), ("servostackbattery", "rTopSplit"))

c.toLibrary("BoatWithServoStackBattery")
