from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("doubleServoMount", "DoubleServoMount", inherit=("lServoMount.depth","lServoMount.width"), prefix=None)
c.inheritAllInterfaces("doubleServoMount")
c.addSubcomponent("espStack", "StackMount", inherit="stack.length", prefix=None)
c.inheritAllInterfaces("espStack")

c.addSubcomponent("portsplit", "SplitEdge")
c.inheritAllInterfaces("portsplit")
c.addConstraint(("portsplit", "toplength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[0]*2+x[1]*2+10*2+x[2],)")
c.addConstraint(("portsplit", "botlength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[2], 10, x[0], x[0]+x[1]*2+10)")

c.addConnection(("doubleServoMount", "lServoInterface"), ("portsplit", "botedge2")) #both face the same direction
c.addConnection(("espStack", "leftArmInterface"), ("portsplit", "botedge0")) #both face the same direction

c.addSubcomponent("starsplit", "SplitEdge")
c.inheritAllInterfaces("starsplit")
c.addConstraint(("starsplit", "toplength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[0] * 2 + x[1] * 2  + 10 * 2 + x[2],)")
c.addConstraint(("starsplit", "botlength"), ("lServoMount.depth", "lServoMount.width", "stack.length"), "(x[0]+x[1]*2+10, x[0], 10, x[2])")

c.addConnection(("doubleServoMount", "rServoInterface"), ("starsplit", "botedge1"))
c.addConnection(("espStack", "rightArmInterface"), ("starsplit", "botedge3"), tabWidth=10)

c.inheritInterface("lmountandservosplit", ("portsplit","topedge0"))
c.inheritInterface("rmountandservosplit", ("starsplit","topedge0"))

c.toLibrary("ServoMountAndStack")
