from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addParameter("servo", "fs90r", paramType="dimension")
# c.addParameter("flip", False, valueType="bool")
# c.addParameter("center", True, valueType="bool")
# c.addParameter("shift", 0, paramType="length")
# XXX TODO: Define type: tuple of two numbers
c.addParameter("offset", optional=True, overrides=("flip", "center", "shift"))

c.addParameter("length", 34, paramType="length")
c.addParameter("width", 20, paramType="length")
c.addParameter("depth", 24, paramType="length")

c.addSubcomponent("beam", "SimpleRectBeam", prefix=None)
c.addSubcomponent("mount", "Cutout")

c.addSubcomponent("servoArm0", "Cutout")
c.addSubcomponent("servoArm1", "Cutout")

c.addParameter("dxServoArm", 4, parameterType="length") #the little servo cutout
c.addParameter("dyServoArm", 12, parameterType="length")

c.addConstraint(("servoArm0", "dx"), "dxServoArm")
c.addConstraint(("servoArm0", "dy"), "dyServoArm")
c.addConstraint(("servoArm1", "dx"), "dxServoArm")
c.addConstraint(("servoArm1", "dy"), "dyServoArm")

c.addSubcomponent("wires", "Cutout")
c.addParameter("wiresDx", 4, parameterType="length") #the little servo cutout
c.addParameter("wiresDy", 9, parameterType="length") #the little servo cutout
c.addConstraint(("wires", "dx"), "wiresDx")
c.addConstraint(("wires", "dy"), "wiresDy")

c.addParameter("dxServo", 23, parameterType="length") #the little servo cutout
c.addParameter("dyServo", 12, parameterType="length")
#
c.addConstraint(("mount", "dx"), "dxServo")
c.addConstraint(("mount", "dy"), "dyServo")
#
c.addConstraint(("beam", "length"), "length")
c.addConstraint(("beam", "width"), "width")
c.addConstraint(("beam", "depth"), "depth")

c.addConnection(("beam", "face0"),
                   ("servoArm0", "decoration"),
                   mode="hole",offset=Function(params=("dxServoArm"), fnstring="(7, 0)"))

c.addConnection(("beam", "face2"),
                   ("servoArm1", "decoration"),
                   mode="hole",offset=Function(params=("dxServoArm"), fnstring="(-7, 0)"))

c.addConnection(("beam", "face1"),
                ("mount", "decoration"),
                mode="hole") #, offset=Function(params=("dy1"), fnstring="(10, 0)")
c.addConnection(("beam", "face2"), ("wires", "decoration"), mode="hole",offset=Function(params=("wiresDx"), fnstring="(5, 0)"))

c.inheritInterface("leftInterface", ("beam", "topedge3"))
c.inheritInterface("rightInterface", ("beam", "botedge3"))

c.toLibrary("SideServoMount")
