from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import Rectangle as Rect


class Rectangle(FoldedComponent):

  def define(self):
    self.addParameter("l", 100, paramType="length")
    self.addParameter("w", 400, paramType="length")

    self.addEdgeInterface("b", "e0", "l")
    self.addEdgeInterface("r", "e1", "w")
    self.addEdgeInterface("t", "e2", "l")
    self.addEdgeInterface("l", "e3", "w")
    self.addFaceInterface("face", "r")

  def assemble(self):
    dx = self.getParameter("l")
    dy = self.getParameter("w")

    self.addFace(Rect("r", dx, dy))

if __name__ == "__main__":
    import sympy

    Rectangle.test()

    # Test sympy
    r = Rectangle()
    r.makeOutput(useDefaultParameters=False, default=False)
    g = r.getGraph()
    for f in g.faces:
        sympy.pprint(f.transform3D)
        sympy.pprint(f.get3DCoords())

